function setupSpellBound() {
	// determine if spellbound is available
	// if not do nothing.
	if (("@mozilla.org/spellchecker;1" in Components.classes) && ("@mozilla.org/spellbound;1" in Components.classes)) {
		var elem = document.getElementById("cmd_spell");
		elem.setAttribute("oncommand", "spellBound_useEditor();");
		elem.setAttribute("disabled", false);
	}
}

function spellBound_useNode() {
	var node = document.getElementById("message");
	var args = [];
	args[0] = node;

	var params = "chrome,close,titlebar,modal";
	var pref = Components.classes["@mozilla.org/preferences-service;1"]
	           .getService(Components.interfaces.nsIPrefBranch);

	try {
		if (pref.getBoolPref("spellbound.spellcheck.modal") == false);
		params = "chrome,close,titlebar";
	} catch (e) { }

	window.openDialog(
	        "chrome://spellbound/content/SBSpellCheck.xul",
	        "_blank", params, false, false, true, args);
}

function spellBound_useNodeArray() {
	var node0 = document.getElementById("nodeId1");
	var node1 = document.getElementById("nodeId2");
	var args = [];
	var nodes = [];
	nodes.push(node0);
	nodes.push(node1);
	args[0] = nodes;

	var params = "chrome,close,titlebar,modal";
	var pref = Components.classes["@mozilla.org/preferences-service;1"]
	           .getService(Components.interfaces.nsIPrefBranch);

	try {
		if (pref.getBoolPref("spellbound.spellcheck.modal") == false);
		params = "chrome,close,titlebar";
	} catch (e) { }

	window.openDialog(
	        "chrome://spellbound/content/SBSpellCheck.xul",
	        "_blank", params, false, false, true, args);
}

// helper function for spellBound_useTextArray
function spellBound_params(sType, sBody, sHead) {
	this.__type = sType;  // must equal text/plain or text/html
	this.__body = sBody;  // text or html to spellcheck
	this.__head = sHead;  // this can be null
	this.__retval = null; // this will be the return value...
	// if nothing was modified this will be null
}

function spellBound_useTextArray() {
	var node0 = document.getElementById("nodeId1");
	var node1 = document.getElementById("nodeId2");
	var node2 = document.getElementById("nodeId3");
	var args = [];

	// span[_moz_misspelled='true'] only applies to text/plain and the
	// user's settings will be used unless they are supplied as shown below
	var style0 = "<style type='text/css'>\n" +
	             "body { background-color:#000080; color:#ffffff; }\n" +
	             "span[_moz_misspelled='true'] { color:#ff0000;\n" +
	             "background:#000000 " +
	             "url(chrome://spellbound/skin/underlines/ff0000.gif; }\n" +
	             "</style>";

	var style1 = "<style type='text/css'>\n" +
	             "body { background-color:#000080; color:#ffffff; }\n" +
	             "</style>";

	args.push(new spellBound_params("text/plain", node0.value, style0));
	args.push(new spellBound_params("text/html", node1.innerHTML, style1));
	args.push(new spellBound_params("text/plain", node2.value, null));

	// modal must be used when using spellBound_useTextArray
	window.openDialog(
	        "chrome://spellbound/content/SBSpellCheck.xul",
	        "_blank","chrome,close,titlebar,modal",
	        false, false, true, args);

	// if __retval is null then the output is the same as the input
	if (args[0].__retval)
		node0.value = args[0].__retval;

	// in some cases you may need to use createElement etc. instead of innerHTML
	if (args[1].__retval)
		node1.innerHTML = args[1].__retval;

	if (args[2].__retval)
		node2.value = args[2].__retval;
}

function spellBound_useEditor() {
	var params = "chrome,close,titlebar,modal";
	var pref = Components.classes["@mozilla.org/preferences-service;1"]
	           .getService(Components.interfaces.nsIPrefBranch);

	/* Had to axe the following, as it causes headaches when SpellCheckOnPost is enabled.
	try {
		if (pref.getBoolPref("spellbound.spellcheck.modal") == false);
		params = "chrome,close,titlebar";
	} catch (e) { }*/

	window.openDialog(
	        "chrome://spellbound/content/SBSpellCheck.xul",
	        "_blank", params, false, false, true);
}

